lkml.org 
[lkml]   [2022]   [Nov]   [14]   [last100]   RSS Feed
Views: [wrap][no wrap]   [headers]  [forward] 
 
Messages in this thread
/
Date
SubjectRe: [PATCH 10/12] perf test: Replace brstack test workload
From


On 10/11/2022 19:20, German Gomez wrote:
> Hi Namhyung, thanks for doing the refactor, it looks a lot cleaner
>
> On 10/11/2022 18:19, Namhyung Kim wrote:
>> So that it can get rid of requirement of a compiler. Also rename the
>> symbols to match with the perf test workload.
>>
>> Cc: German Gomez <german.gomez@arm.com>
>> Signed-off-by: Namhyung Kim <namhyung@kernel.org>
>> ---
>> tools/perf/tests/shell/test_brstack.sh | 66 +++++---------------------
>> 1 file changed, 12 insertions(+), 54 deletions(-)
>>
>> diff --git a/tools/perf/tests/shell/test_brstack.sh b/tools/perf/tests/shell/test_brstack.sh
>> index ec801cffae6b..a8a182dea25f 100755
>> --- a/tools/perf/tests/shell/test_brstack.sh
>> +++ b/tools/perf/tests/shell/test_brstack.sh
>> @@ -4,18 +4,12 @@
>> # SPDX-License-Identifier: GPL-2.0
>> # German Gomez <german.gomez@arm.com>, 2022
>>
>> -# we need a C compiler to build the test programs
>> -# so bail if none is found
>> -if ! [ -x "$(command -v cc)" ]; then
>> - echo "failed: no compiler, install gcc"
>> - exit 2
>> -fi
>> -
>> # skip the test if the hardware doesn't support branch stack sampling
>> # and if the architecture doesn't support filter types: any,save_type,u
>> perf record -b -o- -B --branch-filter any,save_type,u true > /dev/null 2>&1 || exit 2
>>
>> TMPDIR=$(mktemp -d /tmp/__perf_test.program.XXXXX)
>> +TESTPROG="perf test -w brstack"
>>
>> cleanup() {
>> rm -rf $TMPDIR
>> @@ -23,57 +17,24 @@ cleanup() {
>>
>> trap cleanup exit term int
>>
>> -gen_test_program() {
>> - # generate test program
>> - cat << EOF > $1
>> -#define BENCH_RUNS 999999
>> -int cnt;
>> -void bar(void) {
>> -} /* return */
>> -void foo(void) {
>> - bar(); /* call */
>> -} /* return */
>> -void bench(void) {
>> - void (*foo_ind)(void) = foo;
>> - if ((cnt++) % 3) /* branch (cond) */
>> - foo(); /* call */
>> - bar(); /* call */
>> - foo_ind(); /* call (ind) */
>> -}
>> -int main(void)
>> -{
>> - int cnt = 0;
>> - while (1) {
>> - if ((cnt++) > BENCH_RUNS)
>> - break;
>> - bench(); /* call */
>> - } /* branch (uncond) */
>> - return 0;
>> -}
>> -EOF
>> -}
>> -
>> test_user_branches() {
>> echo "Testing user branch stack sampling"
>>
>> - gen_test_program "$TEMPDIR/program.c"
>> - cc -fno-inline -g "$TEMPDIR/program.c" -o $TMPDIR/a.out
>> -
>> - perf record -o $TMPDIR/perf.data --branch-filter any,save_type,u -- $TMPDIR/a.out > /dev/null 2>&1
>> + perf record -o $TMPDIR/perf.data --branch-filter any,save_type,u -- ${TESTPROG} > /dev/null 2>&1
>> perf script -i $TMPDIR/perf.data --fields brstacksym | xargs -n1 > $TMPDIR/perf.script
>>
>> # example of branch entries:
>> - # foo+0x14/bar+0x40/P/-/-/0/CALL
>> + # brstack_foo+0x14/brstack_bar+0x40/P/-/-/0/CALL
>>
>> set -x
>> - egrep -m1 "^bench\+[^ ]*/foo\+[^ ]*/IND_CALL$" $TMPDIR/perf.script
>> - egrep -m1 "^foo\+[^ ]*/bar\+[^ ]*/CALL$" $TMPDIR/perf.script
>> - egrep -m1 "^bench\+[^ ]*/foo\+[^ ]*/CALL$" $TMPDIR/perf.script
>> - egrep -m1 "^bench\+[^ ]*/bar\+[^ ]*/CALL$" $TMPDIR/perf.script
>> - egrep -m1 "^bar\+[^ ]*/foo\+[^ ]*/RET$" $TMPDIR/perf.script
>> - egrep -m1 "^foo\+[^ ]*/bench\+[^ ]*/RET$" $TMPDIR/perf.script
>> - egrep -m1 "^bench\+[^ ]*/bench\+[^ ]*/COND$" $TMPDIR/perf.script
>> - egrep -m1 "^main\+[^ ]*/main\+[^ ]*/UNCOND$" $TMPDIR/perf.script
>> + egrep -m1 "^brstack_bench\+[^ ]*/brstack_foo\+[^ ]*/IND_CALL$" $TMPDIR/perf.script
>> + egrep -m1 "^brstack_foo\+[^ ]*/brstack_bar\+[^ ]*/CALL$" $TMPDIR/perf.script
>> + egrep -m1 "^brstack_bench\+[^ ]*/brstack_foo\+[^ ]*/CALL$" $TMPDIR/perf.script
>> + egrep -m1 "^brstack_bench\+[^ ]*/brstack_bar\+[^ ]*/CALL$" $TMPDIR/perf.script
>> + egrep -m1 "^brstack_bar\+[^ ]*/brstack_foo\+[^ ]*/RET$" $TMPDIR/perf.script
>> + egrep -m1 "^brstack_foo\+[^ ]*/brstsack_bench\+[^ ]*/RET$" $TMPDIR/perf.script
>
> Small typo here s/brstsack_bench/brstack_bench

With this typo fixed and with the other "-b" fix mentioned:

Tested-by: James Clark <james.clark@arm.com>


>
> I think James was doing some BRBE work here, so probably best if he also gives his review/test tag.
>
> Acked-by: German Gomez <german.gomez@arm.com>
>
>> + egrep -m1 "^brstack_bench\+[^ ]*/brstack_bench\+[^ ]*/COND$" $TMPDIR/perf.script
>> + egrep -m1 "^brstack\+[^ ]*/brstack\+[^ ]*/UNCOND$" $TMPDIR/perf.script
>> set +x
>>
>> # some branch types are still not being tested:
>> @@ -88,10 +49,7 @@ test_filter() {
>>
>> echo "Testing branch stack filtering permutation ($filter,$expect)"
>>
>> - gen_test_program "$TEMPDIR/program.c"
>> - cc -fno-inline -g "$TEMPDIR/program.c" -o $TMPDIR/a.out
>> -
>> - perf record -o $TMPDIR/perf.data --branch-filter $filter,save_type,u -- $TMPDIR/a.out > /dev/null 2>&1
>> + perf record -o $TMPDIR/perf.data --branch-filter $filter,save_type,u -- ${TESTPROG} > /dev/null 2>&1
>> perf script -i $TMPDIR/perf.data --fields brstack | xargs -n1 > $TMPDIR/perf.script
>>
>> # fail if we find any branch type that doesn't match any of the expected ones

\
 
 \ /
  Last update: 2022-11-14 12:19    [W:0.099 / U:0.140 seconds]
©2003-2020 Jasper Spaans|hosted at Digital Ocean and TransIP|Read the blog|Advertise on this site